           data    2048

conchan    equ     0               Offset in data area for con channel id


start      bra.s   open            Standard skippy bit
           dc.l    0               Align on byte 6
           dc.w    $4afb           Standard job flag
           dc.w    4               Name size
           dc.b    'SWDF'          Name of this job

condef     dc.w 4
           dc.b "con_"

open       moveq   #1,d0           IO_OPEN
           moveq   #-1,d1          For me
           moveq   #2,d3           New exclusive channel
           lea.l   condef,a0       Channel name
           trap    #2              Open it
           tst.l   d0              Did it work?
           bne     killjob         No

outline    moveq #$7a,d0           IOP.OUTL
           move.l #$00040002,d1    Shadow sizes
           moveq #0,d2             Don't keep contents
           moveq #-1,d3            Timeout
           lea windef,a1           Definition block
           trap #3
           tst.l d0
           bne killjob

paper      moveq #$27,d0           IOW.SPAP
           moveq #4,d1             Paper green
           trap #3
           ; Ignore errors

cls        moveq #$20,d0           IOW.CLRA
           trap #3
           ; Ignore errors!

swdef      lea mainSubw,a1         Pointer to subwin pointers
           lea subwPntr,a4         Actual pointer list
           move.l a4,(a1)          Saved in mainSubw
           lea sub1,a1             First sub window abs address
           move.l a1,(a4)+         Save in list
           lea sub2,a1             Secnd sub window abs address
           move.l a1,(a4)+         Save in list

           moveq #$7d,d0           IOP.SWDF
           moveq #-1,d3            Timeout 
           lea mainSubw,a1         Ptr to Ptr to list of defns
           trap #3                 Do it
           tst.l d0                Ok?
           bne killjob             No

           moveq #0,d1             Pointer coords
loop
           moveq   #$71,d0         IOP_RPTR
           moveq   #%00000001,d2   Return on button/keypress
           lea.l   pointer,a1      Pointer to pointer record
           trap    #3

           cmpi.b #27,$0a(a1)      ESC?
           beq.s killjob           yes     

           bra.s   loop            Let's go round again

mainSubw   dc.l    0               Pointer to sub windows pointer table
windef     dc.w    200,100,50,50 w,h,x,y 
         
           dc.w    0               Spare
           dc.w    1               Border width
           dc.w    0               Border colour
           dc.w    7               Paper colour
           dc.l    $00             Use ARROW Pointer

subwPntr   dc.l    0
           dc.l    0
           dc.l    0

sub1       dc.l    0               Pointer to sub windows pointer table
           dc.w    196,20,2,2      w,h,x,y  (x,y relative to main window) 
       
           dc.w    0               Spare
           dc.w    1               Border width
           dc.w    0               Border colour
           dc.w    2               Paper colour
           dc.l    $0a             Use SLEEP Pointer

sub2       dc.l    0               Pointer to sub windows pointer table
           dc.w    196,20,2,78     w,h,x,y  (x,y relative to main window) 
       
           dc.w    0               Spare
           dc.w    1               Border width
           dc.w    4               Border colour
           dc.w    2               Paper colour
           dc.l    $0a             Use SLEEP Pointer
pointer    ds.w    12              Pointer record for IOP_RPTR


killjob    move.l  d0,d3           Error code
           moveq   #5,d0           MT_FRJOB
           moveq   #-1,d1          Me
           trap    #1              Bye bye
           bra.s   killjob         Just in case!
